; ================================================================================================
; HPS SONG (Super Smash Bros. Melee, Kirby Air Ride)
; ================================================================================================

; --------------------------------------------
; Settings
; --------------------------------------------

Samples		equ	%samples%
SampleRate	equ	%samplerate%
Blocks		equ	%blocks%
; --------------------------------------------
; (DON'T TOUCH THESE ONES)
; --------------------------------------------

ID		=	0
NextAddr	=	0x60

; ================================================================================================

; --------------------------------------------
; MACRO - Normal block
; --------------------------------------------

BlockData	macro	Len,Arg2

BlockPos\@:
		dc.l	DspEnd\@-DspStart\@				;length of the block
		dc.l	DspEnd\@-DspStart\@-1				;last byte to read in the block

	if Arg2=0
		dc.l	DspEnd\@					;offset for next block to read (looping done this way)
	else
		inform 0,"-LOOP BLOCK-"
		dc.l	\2
	endif
		incbin	"dsp/LEFT.dsp",0x3E,0x08			;left channel decoder state
		incbin	"dsp/RIGHT.dsp",0x3E,0x08			;right channel decoder state
		dc.l	0						;empty (00 00 00 00)

; ----------------------------------

DspStart\@:
		incbin "dsp/LEFT.dsp",(NextAddr),Len
RightAudio\@:	incbin "dsp/RIGHT.dsp",(NextAddr),Len

DspEnd\@:
; ----------------------------------

ID		=	ID+1
NextAddr	=	NextAddr+Len

		inform 0,"[BLOCK %d, Addr: $%h]",ID,BlockPos\@
		inform 0,"Left:  $%h $%h",DspStart\@,((RightAudio\@)-1)
		inform 0,"Right: $%h $%h",RightAudio\@,((DspEnd\@)-1)

		endm

; ================================================================================================
; HEADER
; ================================================================================================

; --------------------------------------------
; Header, Main
; --------------------------------------------

		dc.b " HALPST",0				;Magic
		dc.l SampleRate					;Sample rate
		dc.l 2						;Channels

; --------------------------------------------
; Header, Left Channel
; --------------------------------------------

		dc.l $00010000					;length of largest block
		dc.l 2						;???
		dc.l Samples+$30000				;"samples to read", Left
		dc.l 2						;???
		incbin "dsp/LEFT.dsp",0x1C,0x20			;channel decoder, left
		cnop 0,$48

; --------------------------------------------
; Header, Right Channel
; --------------------------------------------

		dc.l $00010000					;length of largest block
		dc.l 2						;???
		dc.l Samples+$30000				;"samples to read", Left
		dc.l 2						;???
		incbin "dsp/RIGHT.dsp",0x1C,0x20		;channel decoder, left
                cnop 0,$80

; ================================================================================================
; Main data
; ================================================================================================

BlockStart:
		rept %blockstart%
		BlockData 0x2000,0
		endr
BlockLoop:
		rept %blockend%
		BlockData 0x2000,0
		endr

		BlockData 0x2000,BlockLoop
		even
